'
' CRANE ver 0.5
'  by ChangeV
'  2007 JawsV soft
'

'#define quick_end  'quit game with Esc key without quit-menu.

#define clrscr LOCATE 1, 1: ? STRING(1200, &h20);'clear screen with 1200 spaces

'log
'
'7-20-2007 
' project started
'
' tested basic game engine with 640 x 480...gameplay sucks...
' changed 640x480 to 320x240
' replaced inkey with multikey
' state based crane movement (solved diagonal move problem)
' added inkey based spacekey routine to crane-state. (for open/close the claw)
'
'7-22-2007
' posted FB BBS, asking if ascii gfx is ok?
' seems ok with everyone. I will continue this project.
'
' make game over routine
' changed to 'time over' message
' replaced space inkey to multikey
' added quit menu
'
'7-29-2007
' added color to objects/letters
'
'7-30-2007
' hiscore loading & saving
' 9 sec remaining = blink timer
' change background colors for each stage
' added junk into the field
' added how to play screen
' incresed extra time by 1 per stage. (when drop package)
'
'7-30-2007 night (usually 3-40 min around midnight)
' adjusted total time and bonus time, junk rate, new package ...etc
'
'7-30-2007 late night
' adding more starting-time
' adding guiding arrow on the crane track
' removing global variables and passing them as parameter(crane., truck., game.)
'
'8-1-2007 almost midnight
' change the "GAME." variable back to global. because it was messy...
' making screen shot of stage 1.
' changed ground color a bit. above screenshot is useless...
'
'8-3-2007 afternoon
' added crane in How-to-Play screen (forgot to draw)
' arranging order of subs (looks nice)
' clean up here and there. adding white spaces here and there.
' feel like finally finished
' adjusted: no limit on total game time and bonus time...
'
'8-4-2007 afternoon
' changed back the game time to 300, bonus time to 10.
'
'8-5-2007 noon
' added score and hiscore at title screen
'
'8-5-2007 at night
' correct 2 typo
'

CONST false = 0
CONST true = NOT false

ENUM claw_state
   is_opened = 0
   is_closed = 1
END ENUM

ENUM crane_state
   idle = 0
   move_left
   move_right
   move_up
   move_down
   use_claw
   drop
END ENUM

ENUM truck_state
   truck_init = 0
   truck_move 
   truck_waiting
   truck_pause
   truck_deliver
END ENUM

TYPE game_type
   quit AS INTEGER
   EXIT AS INTEGER
   time_over AS INTEGER
   stage_clear AS INTEGER
   TIME AS INTEGER
   stage AS INTEGER
   score AS INTEGER
   hiscore AS INTEGER
   timer_blink AS INTEGER
   extra_time AS INTEGER
   max_letter AS INTEGER
   target AS INTEGER
END TYPE

TYPE crane_type
   state AS crane_state
   x AS INTEGER
   y AS INTEGER
   oldx AS INTEGER
   oldy AS INTEGER
   claw AS claw_state
   package AS INTEGER
END TYPE

TYPE truck_type
   state AS truck_state
   x AS INTEGER
   stop_position AS INTEGER
   delay AS INTEGER
   package AS INTEGER
   package_position AS INTEGER
END TYPE

DECLARE SUB save_hiscore(BYVAL hiscore AS INTEGER)
DECLARE SUB load_hiscore(BYREF hiscore AS INTEGER)

DECLARE SUB title(BYREF selection AS INTEGER)
DECLARE SUB how_to_play()
DECLARE SUB quit_menu(BYREF selection AS INTEGER)
DECLARE SUB time_over()

DECLARE SUB draw_background(BYVAL stage AS INTEGER)
DECLARE SUB draw_score(BYVAL extra_msg AS INTEGER = 0)
DECLARE SUB draw_crane(BYVAL object AS crane_type)
DECLARE SUB draw_truck(BYVAL object AS truck_type)

DIM AS crane_type crane
DIM AS truck_type truck

DIM SHARED AS game_type game
DIM SHARED AS INTEGER BG_color

DIM AS STRING key
DIM AS INTEGER i, j, x, y
DIM AS INTEGER old_timer, new_timer
DIM AS INTEGER time_bonus_message, time_bonus_message_timer
DIM AS INTEGER space_key_released

RANDOMIZE TIMER

'set 320x240 FULL SCREEN and hide mouse
SCREEN 14, 8, 0, 1 '320x240. 8bit colors. 0 video page. Fullscreen mode
WIDTH 40, 30 'actually...not needed. scren 14 is 40x30 only...
SETMOUSE , , 0 'hide mouse

LOAD_hiscore(game.hiscore)

DO
   
   title(game.exit) 'return exit-code if player hits Esc key
   
   IF NOT game.exit THEN
      
      how_to_play()
      
      game.score = 0
      
      game.stage = 0
      
      DO
         game.time_over = false
         game.stage_clear = false
         
         game.stage += 1
         IF game.stage > 99 THEN game.stage = 99
         
         game.max_letter = game.stage * 3
         IF game.max_letter > 26 THEN game.max_letter = 26
         
         game.time = 40 + game.stage * 30
         IF game.time > 300 THEN game.time = 300
         
         'bonus time when drop letter on the truck
         game.extra_time = 4 + game.stage
         IF game.extra_time >10 THEN game.extra_time = 10
         
         game.target = 65 'starting with "A"
         
         crane.x = 5
         crane.y = 6
         crane.state = idle
         crane.claw = is_opened
         crane.package = &h20
         
         truck.state = truck_init
         
         draw_background(game.stage)
         
         'add letters and some junk too
         i = 1
         DO
            x = INT (RND * 30) +5
            y = INT (RND * 18) + 7
            IF SCREEN(y, x - 1) = 32 AND SCREEN(y, x + 1) = 32 AND SCREEN(y, x) = 32 THEN
               LOCATE y, x
               'add junk in later levels
               IF i > game.max_letter THEN
                  COLOR 0
                  ? "*"; 'junk !.  can be moved, but truck won't accept it.
               ELSE
                  COLOR 14 - (i MOD 5) 'regular colored letters
                  ? CHR(64 + i);
               END IF
               i += 1
            END IF
         LOOP UNTIL i > game.max_letter + (game.stage - 1) * 2
         
         DO
            'user input section
            key = INKEY
            game.quit = (key = CHR(27))
            
            crane.oldx = crane.x
            crane.oldy = crane.y
            
            crane.state = idle
            
            'L/R movement when on the crane track
            IF (MULTIKEY(&h4d)) AND crane.y = 6 THEN crane.state = move_right
            IF (MULTIKEY(&h4b)) AND crane.y = 6 THEN crane.state = move_left
            
            'U/D movement
            IF (MULTIKEY(&h48) AND (NOT MULTIKEY(&h50))) THEN crane.state = move_up
            IF (MULTIKEY(&h50) AND (NOT MULTIKEY(&h48))) AND (SCREEN(crane.y + 1, crane.x - 1) = 32) AND (SCREEN(crane.y + 1, crane.x + 1) = 32) AND (SCREEN(crane.y + crane.claw, crane.x) = 32) THEN
               crane.state = move_down
            END IF
            
            'space key  = pick up or release
            IF MULTIKEY(&h39) THEN
               IF space_key_released THEN
                  space_key_released = false
                  crane.state = use_claw
               END IF
            ELSE
               space_key_released = true
            END IF
            
            'put it on the truck
            IF crane.y = 24 AND crane.package > 32 THEN 'reach bottom with letter...
               IF SCREEN(crane.y+1, crane.x) = &h5f THEN 'if truck is waiting...
                  IF crane.package = game.target THEN 'if it is what truck wants...
                     crane.state = drop
                     time_bonus_message = true
                     time_bonus_message_timer = 6 'show bonus message 6 frames
                     game.time += game.extra_time
                     if game.time >999 then game.time = 999
                  END IF
               END IF
            END IF
            '- end of user input section -
            
            '- crane section -
            SELECT CASE AS CONST crane.state
            CASE move_right
               if crane.x < 35 then crane.x += 1
               
            CASE move_left
               if crane.x > 5 then crane.x -= 1
               
            CASE move_up
               if crane.y > 6 then crane.y -= 1
               
            CASE move_down
               if crane.y < 24 then crane.y += 1
               
            CASE use_claw 'if something is under the claw, you can grab it.
               IF (crane.claw = is_opened) AND (SCREEN(crane.y, crane.x) > 32) THEN
                  crane.claw = is_closed
                  crane.package = SCREEN(crane.y, crane.x)
               ELSE
                  'you can release letter into game field
                  IF crane.y > 6 THEN 'if not on the crane track
                     crane.claw = is_opened
                     crane.package = &h20
                  END IF
               END IF
               
            CASE drop
               crane.claw = is_opened
               truck.package = crane.package
               crane.package = &h20
               truck.package_position = (crane.x + truck.x) AND 1
               crane.state = idle
               truck.state = truck_pause ' wait 3 frames so player can see
               LOCATE crane.y, crane.x: ? " "; 'remove package from screen when claw drops it
               
            END SELECT
            
            draw_crane(crane)
            '- end of crane section -
            
            '- truck section -
            SELECT CASE AS CONST truck.state
            CASE truck_init
               truck.x = -3 'out of screen
               truck.delay = 0
               truck.package = &h20
               truck.stop_position = INT(RND * 30) + 3 'where to stop
               truck.state = truck_move
               
            CASE truck_move
               truck.x += 1
               IF truck.x > truck.stop_position THEN truck.state = truck_waiting
               
            CASE truck_waiting
               'do nothing
               
            CASE truck_pause
               'got the package. pause few frames so player can see.
               truck.delay += 1
               IF truck.delay > 4 THEN truck.state = truck_deliver
               
            CASE truck_deliver
               truck.x += 1
               IF truck.x > 40 THEN 'go inside the warehouse
                  truck.state = truck_init
                  game.score += 10
                  IF game.score > game.hiscore THEN game.hiscore = game.score
                  game.target += 1 'truck will accept next letter
                  'check if that was the last package... then Stage clear
                  game.stage_clear = game.target > 64 + game.max_letter
               END IF
               
            END SELECT
            
            draw_truck(truck)
            '- end of truck section -
            
            'open the quit menu
            #ifndef quick_end
            IF game.quit THEN quit_menu(game.quit)
            #ENDIF
            
            '- score section -
            'score display and extra message stuff
            IF time_bonus_message_timer > 0 THEN
               time_bonus_message_timer -= 1
            ELSE
               time_bonus_message = false
            END IF
            
            'timer for game time
            old_timer = new_timer
            new_timer = INT(TIMER)
            IF old_timer <> new_timer THEN
               game.time -= 1
               IF game.time < 0 THEN
                  game.time = 0
                  game.time_over = true
               END IF
               
            END IF
            draw_score (time_bonus_message)
            '- end of score section -
            
            WHILE INKEY <> "": WEND
            SLEEP 90, 1
            
         LOOP UNTIL game.quit OR game.stage_clear OR game.time_over
         
         '- stage clear section -
         IF game.stage_clear THEN 'put some stage clear message
            
            'stage clear message
            LOCATE 11, 15: ? STRING(13, 32);
            LOCATE 12, 15: ? " Stage Clear ";
            LOCATE 13, 15: ? STRING(13, 32);
            LOCATE 16, 13: ? STRING(17, 32);
            LOCATE 17, 13: ? " Time x 10 = ";RIGHT("   " + STR(game.time * 10), 4); " ";
            LOCATE 18, 13: ? STRING(17, 32);
            SLEEP 500, 1
            
            'counting down from left side. much quicker.
            'score counting x1xx
            FOR i = 1 TO (game.time \ 100) MOD 10
               game.time -= 100
               game.score += 1000
               IF game.score > game.hiscore THEN game.hiscore = game.score
               LOCATE 17, 13: ? " Time x 10 = "; RIGHT("   " + STR(game.time * 10), 4); " ";
               draw_score()
               SLEEP 100, 1
            NEXT
            'score counting xx1x
            FOR i = 1 TO (game.time \ 10) MOD 10
               game.time -= 10
               game.score += 100
               IF game.score > game.hiscore THEN game.hiscore = game.score
               LOCATE 17, 13: ? " Time x 10 = "; RIGHT("   " + STR(game.time * 10), 4); " ";
               draw_score()
               SLEEP 100, 1
            NEXT
            'score counting xxx1
            FOR i = 1 TO game.time MOD 10
               game.time -= 1
               game.score += 10
               IF game.score > game.hiscore THEN game.hiscore = game.score
               LOCATE 17, 13: ? " Time x 10 = "; RIGHT("   " + STR(game.time * 10), 4); " ";
               draw_score()
               SLEEP 100, 1
            NEXT
            
            COLOR 15', BG_color
            SLEEP 1000, 1
            
         END IF
         '- end of stage clear section -
         
         '- time over section -
         IF game.time_over THEN
            
            'just put big TIME OVER for a few seconds
            time_over()
            
         END IF
         '- end of time over section -
         
      LOOP UNTIL game.quit OR game.time_over 'exit to title screen
      
      'take care of hiscore
      IF game.score = game.hiscore THEN save_hiscore(game.hiscore)
      
   END IF
   
LOOP UNTIL game.exit

'clean up
WHILE INKEY <> "": WEND

END

'----------------------------------------------------------------------
SUB save_hiscore(BYVAL  hiscore AS INTEGER)
   OPEN "hiscore.txt" FOR OUTPUT AS #1
   PRINT #1, "hi-score" 
   PRINT #1, hiscore
   CLOSE #1
END SUB

'----------------------------------------------------------------------
SUB load_hiscore(BYREF hiscore AS INTEGER)
   
   DIM AS INTEGER hiscore_filesize
   DIM AS STRING dummy_string
   
   'check if there is hi-score file
   OPEN "hiscore.txt" FOR APPEND AS #1
   hiscore_filesize = LOF(1)
   CLOSE #1
   
   'if not found then initialize with 1000 pts
   IF hiscore_filesize = 0 THEN
      hiscore = 1000
      save_hiscore(hiscore)
   ELSE 'if found then load it from file
      OPEN "hiscore.txt" FOR INPUT AS #1
      INPUT #1, dummy_string
      INPUT #1, hiscore
      CLOSE #1
   END IF
END SUB

'----------------------------------------------------------------------
SUB title (BYREF selection AS INTEGER)
   
   DIM AS STRING key
   COLOR 15, 9
   clrscr
   
   COLOR 15
   LOCATE 2, 2: ? "Score  "; RIGHT("0000000" + STR(game.score), 8);
   LOCATE 2, 21: ? " Hi-Score  "; RIGHT("0000000" + STR(game.hiscore), 8);
   
   LOCATE 1, 1
   ?:?:?:?:?:?:?:?
   ? "    CCC   RRRR     A    N   N  EEEEE"
   ? "   C   C  R   R   A A   NN  N  E    "
   ? "   C      RRRR   AAAAA  N N N  EEEE "
   ? "   C   C  R   R  A   A  N  NN  E    "
   ? "    CCC   R   R  A   A  N   N  EEEEE"
   ?:?:?:?:?:?:?:?:?
   ? "            press space key"
   ?:?:?:?:?
   ?"                        2007 JawsV soft";
   DO
      key = INKEY
      if key = chr(27) then selection = true else selection = false
      SLEEP 10, 1
   LOOP UNTIL INSTR(CHR(27, 32), key) 'Esc or Space
   
END SUB

'----------------------------------------------------------------------
SUB how_to_play()
   STATIC played_first_time AS INTEGER = true
   
   IF played_first_time THEN
      
      played_first_time = false
      
      clrscr
      
      LOCATE 2, 4: color 7: ? CHR(&hda); STRING(10, &hc2); CHR(&hbf);
      LOCATE 3, 9: COLOR 8: ? CHR(&hb3);
      LOCATE 4, 8: COLOR 7: ? CHR(&hda, &hc1, &hbf);
      LOCATE 5, 8: ? "/ \";
      LOCATE 6, 9: COLOR 15: ? CHR(&h18);
      LOCATE 7, 9: COLOR 15: ? "|";
      LOCATE 8, 9: COLOR 15: ? CHR(&h19);
      
      COLOR 15
      LOCATE 5, 5: ? CHR(&h1b, &h2d);
      LOCATE 5, 12: ? CHR(&h2d, &h1a);
      LOCATE 2, 18: ? " CRANE can only move ";
      LOCATE 4, 18: ? "    LEFT or RIGHT    ";
      LOCATE 6, 18: ? "  when it is at the  ";
      LOCATE 8, 18: ? "  highest position   ";
      
      LOCATE 10, 2: ? STRING(38, &hc4);
      
      COLOR 8
      LOCATE 12,4: ? CHR(&hb3);
      LOCATE 13,4: ? CHR(&hb3);
      LOCATE 14,4: ? CHR(&hb3);
      LOCATE 15,4: ? CHR(&hb3);
      LOCATE 16,4: ? CHR(&hb3);
      COLOR 12: ? "  B";
      COLOR 11: ? " C";
      COLOR 10: ? " D";
      COLOR 14: ? " E";
      
      LOCATE 17, 3: COLOR 7: ? CHR(&hda, &hc1, &hbf);
      LOCATE 18, 3: ? "\";: COLOR 13: ? "A";: COLOR 7: ? "/";
      LOCATE 20, 4: COLOR 15: ? "__";: COLOR 11: ? CHR(&hdb);
      LOCATE 21, 4: COLOR 0: ? "O O";
      
      COLOR 15
      LOCATE 12, 18: ? "   use SPACE KEY to   "
      LOCATE 14, 18: ? "  PICK UP or RELEASE  "
      LOCATE 16, 18: ? "    the letter and    "
      LOCATE 18, 18: ? " DROP it on the TRUCK "
      LOCATE 20, 18: ? "    alphabetically    "
      
      LOCATE 22, 2: ? STRING(38, &hc4)
      ?
      ? "    Move other letters first if they   "
      ? "      block your way to the truck      "
      ?
      ? " When CRANE is at the highest position,"
      ? "      it can't release the letter.     "
      ? "             be careful !              "
      
      DO: SLEEP 10, 1: LOOP UNTIL LEN(INKEY)
   END IF
   
END SUB

'----------------------------------------------------------------------
SUB quit_menu(BYREF selection AS INTEGER)
   
   DIM AS INTEGER i, j
   DIM AS BYTE background(12, 2), background_color(12, 2)
   DIM AS STRING key
   
   'save background data before drawing the menu
   FOR j = 0 TO 2
      FOR i = 0 TO 12
         background(i, j) = SCREEN(j + 14, i + 14) 'get ascii data
         background_color(i, j) = SCREEN(j + 14, i + 14, 1) 'get color
      NEXT
   NEXT
   
   'draw menu
   COLOR 15
   LOCATE 14, 14: ? CHR(&hda); STRING(11, &hc4); CHR(&hbf);
   LOCATE 15, 14: ? CHR(&hb3); "QUIT? [Y/N]"; CHR(&hb3);
   LOCATE 16, 14: ? CHR(&hc0); STRING(11, &hc4); CHR(&hd9);
   
   DO
      key = UCASE(INKEY)
      if key ="Y" then selection = true else selection = false
      draw_score()
      SLEEP 90, 1
   LOOP UNTIL INSTR(CHR(&h1b, &h59, &h4e), key) 'Y or N or Esc
   
   'restore the background that was destroyed by menu
   FOR j = 0 TO 2
      FOR i = 0 TO 12
         COLOR background_color(i, j) AND &hf
         LOCATE j + 14, i + 14
         ? CHR(background(i, j));
      NEXT
   NEXT
   
END SUB

'----------------------------------------------------------------------
SUB time_over ()
   'erase play field
   COLOR 15
   LOCATE 4, 1
   ? "                                    "
   ? "                                    "
   ? "                                    "
   ? "                                    "
   ? "       TTTTT   III   M   M  EEEEE   "
   ? "         T      I    MM MM  E       "
   ? "         T      I    M M M  EEE     "
   ? "         T      I    M M M  E       "
   ? "         T     III   M   M  EEEEE   "
   ? "                                    "
   ? "                                    "
   ? "                                    "
   ? "                                    "
   ? "        OOO   V   V  EEEEE  RRRR    "
   ? "       O   O  V   V  E      R   R   "
   ? "       O   O  V   V  EEEE   RRRR    "
   ? "       O   O   V V   E      R   R   "
   ? "        OOO     V    EEEEE  R   R   "
   ? "                                    "
   ? "                                     "
   ? "                                     "
   ? "                                     "
   ? "                                     "
   SLEEP 3000, 1
   
END SUB

'----------------------------------------------------------------------
SUB draw_background(BYVAL stage AS INTEGER)
   
   DIM AS INTEGER i, j
   
   'set different background color for each stages
   SELECT CASE AS CONST (stage MOD 5)
   CASE 0: BG_color = 2
   CASE 1: BG_color = 9
   CASE 2: BG_color = 6
   CASE 3: BG_color = 1
   CASE 4: BG_color = 5
   CASE ELSE: BG_color = 4
   END SELECT
   
   COLOR 15, BG_color
   
   game.timer_blink = BG_color 'and reset the color of timer blinker too
   
   'clear the screen with 1200 spaces.
   clrscr
   
   'crane track
   COLOR 7
   LOCATE 3, 5: ? CHR(&hda); STRING(29, &hc2); CHR(&hbf);
   
   'warehouse
   COLOR 7: LOCATE 22, 37: ? CHR(&hde, &hdb, &hdb, &hdb);
   COLOR 7, 8: LOCATE 23,38 : ? CHR(&hdc, &hdc, &hdc);
   COLOR 7, 8: LOCATE 24,38 : ? CHR(&hdb, &hce, &hdb);
   COLOR 8, 7: LOCATE 24,38 : ? CHR(&h20, &hce, &h20);
   COLOR 7, 15:LOCATE 25,38 : ? CHR(&hdb, &hdb, &hdb);
   COLOR 7, 15:LOCATE 26,38 : ? CHR(&hdb, &hdb, &hdb);
   
   'ground
   COLOR 8, 1
   LOCATE 27,1: ? STRING(40, &hb2);
   
   COLOR 15, BG_color
   
END SUB

'----------------------------------------------------------------------
SUB draw_score(BYVAL extra_msg AS INTEGER = 0)
   
   COLOR 15
   LOCATE 2, 2: ? "Score  "; RIGHT("0000000" + STR(game.score), 8);
   LOCATE 2, 21: ? " Hi-Score  "; RIGHT("0000000" + STR(game.hiscore), 8);
   
   LOCATE 29, 2:? "Time ";
   'blink when remaining time is less than 9 seconds
   IF NOT(game.stage_clear) AND (game.time > 0 AND game.time < 10) THEN
      game.timer_blink = (15 + BG_color) - game.timer_blink
   ELSE 'don't blink when stage-clear timer count down.
      game.timer_blink = 15
   END IF
   COLOR game.timer_blink
   ? RIGHT("00" + STR(game.time), 3);
   
   'and put bonus time message if needed
   COLOR 15
   IF extra_msg THEN ? " +";STR(game.extra_time);" sec"; ELSE ? "        ";
   
   LOCATE 29, 32: ? "Stage "; RIGHT("0" + STR(game.stage), 2);
   
END SUB

'----------------------------------------------------------------------
SUB draw_crane(BYVAL object AS crane_type)
   
   DIM AS INTEGER i
   
   LOCATE 4, object.x - 2
   COLOR 8
   'add guiding arrow on the track when crane is at the highest position.
   IF object.y = 6 THEN
      ? CHR(&h20, &h1b, &hb3, &h1a, &h20);
   ELSE
      ? CHR(&h20, &h20, &hb3, &h20, &h20);
   END  IF
   
   'draw crane wire
   FOR i = 5 TO object.y - 2
      LOCATE i, object.x - 1
      ? CHR(&h20, &hb3, &h20);
   NEXT
   
   'draw claw base joint
   COLOR 7
   IF object.y < object.oldy THEN LOCATE object.oldy - 1, object.oldx: ? " ";
   LOCATE object.y - 1, object.x - 1: ? CHR(&hda, &hc1, &hbf);
   
   'erase old claw base joint
   IF object.x > object.oldx THEN LOCATE object.y - 1, object.x - 2: ? " ";
   IF object.x < object.oldx THEN LOCATE object.y - 1, object.x + 2: ? " ";
   
   'draw claw
   COLOR 7
   SELECT CASE AS CONST object.claw
   
   CASE is_opened
      LOCATE object.y, object.x - 1: ? "/";
      LOCATE object.y, object.x + 1: ? "\";
      
   CASE is_closed
      LOCATE object.y, object.x - 1: ? "\";
      
      'add colored letter
      IF object.package = &h2a THEN 'if picked up a junk
         COLOR 0
      ELSE 'if picked up A~Z
         COLOR 14 - ((object.package - 64) MOD 5)
      END IF
      
      ? CHR(object.package);
      
      COLOR 7
      ? "/";
      
   END SELECT
   
   'erase old crane when moving sideways
   IF object.x > object.oldx THEN
      LOCATE object.y, object.x - 2: ? " ";
      IF object.claw = is_opened THEN LOCATE object.y, object.x: ? " ";
   END IF
   
   'erase old crane when moving sideways
   IF object.x < object.oldx THEN
      LOCATE object.y, object.x + 2: ? " ";
      IF object.claw = is_opened THEN LOCATE object.y, object.x: ? " ";
   END IF
   
   'erase old crane when move up
   IF object.y < object.oldy THEN
      LOCATE object.oldy, object.x - 1: ? " ";
      LOCATE object.oldy, object.x + 1: ? " ";
      IF object.claw = is_closed THEN LOCATE object.oldy, object.x: ? " ";
   END IF
   
END SUB

'----------------------------------------------------------------------
SUB draw_truck(BYVAL object AS truck_type)
   
   DIM AS STRING truck_top, truck_bottom, piece
   DIM AS INTEGER i
   
   'build up a truck, so it can be chopped when clip
   IF object.package_position = 0 THEN
      truck_top = " _" + CHR(IIF(object.package <= 32, &h5f, object.package)) + CHR(&hdb)
   ELSE
      truck_top = " " + CHR(IIF(object.package <= 32, &h5f, object.package)) + "_" + CHR(&hdb)
   END IF
   truck_bottom = " O O"
   
   'clip - trim the back of the truck
   IF object.x<=0 THEN
      truck_top = RIGHT(truck_top,3+object.x)
      truck_bottom = RIGHT(truck_bottom,3+object.x)
      object.x=1
   END IF
   
   'clip - trim the front of the truck
   IF object.x>34 THEN 
      truck_top = LEFT(truck_top,3+(35-object.x))
      truck_bottom = LEFT(truck_bottom,3+(35-object.x))
   END IF
   
   'prevent outside of screen
   IF object.x > 40 THEN object.x = 40
   
   COLOR 15
   
   'draw truck top part. adding color piece by piece
   FOR i = 1 TO LEN(truck_top)
      piece = MID(truck_top, i, 1)
      IF piece = CHR(&hdb) THEN 'driver's window part
         COLOR 11
      ELSE
         IF piece >= CHR(&h41) AND piece <= CHR(&h5a) THEN
            COLOR  14 - ((ASC(piece) - 64) MOD 5) 'letter
         ELSE 
            COLOR 15 'empty area on truck
         END IF
      END IF
      LOCATE 25, object.x + i - 1: ? MID(truck_top, i, 1);
   NEXT
   
   'draw truck bottom part. black tires
   COLOR 0
   LOCATE 26, object.x: ? truck_bottom
   
END SUB

'----------------------------------------------------------------------
